<template>
	<div class="statistics-call-detail-talk-time-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<el-form :model="state.queryParams" ref="ruleFormRef" @submit.native.prevent inline v-if="showSearch">
				<el-form-item prop="crTime">
					<statistical-time v-model="state.queryParams.crTime" @change="handleQuery" ref="statisticalTimeRef" :disabled="state.loading" />
				</el-form-item>
				<el-form-item label="状态" prop="type">
					<el-select v-model="state.queryParams.type" placeholder="请选择状态" clearable @change="handleQuery">
						<el-option v-for="item in state.callForwardingType" :value="item.dicDataValue" :key="item.dicDataValue" :label="item.dicDataName" />
					</el-select>
				</el-form-item>
				<el-form-item label="来源" prop="source">
					<el-select v-model="state.queryParams.source" placeholder="请选择来源" clearable @change="handleQuery">
						<el-option v-for="item in state.callForwardingSource" :value="item.dicDataValue" :key="item.dicDataValue" :label="item.dicDataName" />
					</el-select>
				</el-form-item>
				<el-form-item label-width="0">
					<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" class="default-button" :loading="state.loading">
						<SvgIcon name="ele-Refresh" class="mr5" />重置
					</el-button>
				</el-form-item>
			</el-form>
			<vxe-toolbar
				ref="toolbarRef"
				:loading="state.loading"
				custom
				:refresh="{
					queryMethod: queryList,
				}"
			>
			</vxe-toolbar>
			<div style="overflow: hidden; width: 100%; height: 100%; flex: 1">
				<vxe-table
					border
					:loading="state.loading"
					:data="state.tableData"
					:column-config="{ resizable: true }"
					:row-config="{ isCurrent: true, isHover: true, height: 30, useKey: true }"
					ref="tableRef"
					height="auto"
					auto-resize
					show-overflow
					:scrollY="{ enabled: true, gt: 100 }"
					id="statisticsCallDetailTalkTime"
					:custom-config="{ storage: true }"
					showHeaderOverflow
				>
					<vxe-column field="cpn" title="主叫号码"></vxe-column>
					<vxe-column field="cdpn" title="被叫号码"></vxe-column>
					<vxe-column field="createdTime" title="来电时间" width="160">
						<template #default="{ row }">
							{{ formatDate(row.createdTime, 'YYYY-mm-dd HH:MM:SS') }}
						</template>
					</vxe-column>
				</vxe-table>
			</div>
			<pagination
				@pagination="queryList"
				:total="state.total"
				v-model:current-page="state.queryParams.PageIndex"
				v-model:page-size="state.queryParams.PageSize"
				:disabled="state.loading"
			/>
		</div>
	</div>
</template>
<script setup lang="tsx" name="statisticsCallDetailTalkTime">
import { computed, defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { FormInstance } from 'element-plus';
import { callPeriodBase, callPeriodDetail } from '@/api/statistics/call';
import { defaultDate } from '@/utils/constants';
import { formatDate } from '@/utils/formatTime';
import { useRoute } from 'vue-router';
import Other from '@/utils/other';

const StatisticalTime = defineAsyncComponent(() => import('@/components/StatisticalTime/index.vue')); // 日期类型选择组件
const pagination = defineAsyncComponent(() => import('@/components/ProTable/components/Pagination.vue')); // 分页
// 定义变量内容
const ruleFormRef = ref<RefType>(); // 表单ref
const state = reactive<any>({
	queryParams: {
		// 查询条件
		type: null,
		source: null,
		crTime: defaultDate,
		PageIndex: 1,
		PageSize: 20,
		startHourTo: null,
	},
	tableData: [], //表单
	loading: false, // 加载
	total: 0, // 总数
	callForwardingSource: [],
	callForwardingType: [],
});
/** 搜索按钮操作 */
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
/** 获取列表 */
const requestParams = ref<EmptyObjectType>({});
const queryList = () => {
	state.loading = true;
	if (route.query.type) {
		state.queryParams.type = route.query.type;
	}
	if (route.query.startHourTo) state.queryParams.startHourTo = route.query.startHourTo;
	state.loading = true;
	requestParams.value = Other.deepClone(state.queryParams);
	requestParams.value.StartTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[0];
	requestParams.value.EndTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[1];
	Reflect.deleteProperty(requestParams.value, 'crTime');
	callPeriodDetail(requestParams.value)
		.then((res: any) => {
			state.tableData = res.result?.data ?? [];
			state.total = res.result?.total ?? 0;
			state.loading = false;
		})
		.catch(() => {
			state.loading = false;
		});
};
/** 重置按钮操作 */
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
};
// 获取基础信息
const getBaseInfo = async () => {
	try {
		const { result } = await callPeriodBase();
		state.callForwardingSource = result.callForwardingSource ?? [];
		state.callForwardingType = result.callForwardingType ?? [];
	} catch (e) {
		console.log(e);
	}
};
// 是否展示查询条件
const route = useRoute();
const showSearch = computed(() => {
	return route.query.showSearch;
});
const toolbarRef = ref<RefType>();
const tableRef = ref<RefType>();
onMounted(() => {
	if (route.query.StartTime) {
		state.queryParams.crTime = [route.query.StartTime, route.query.EndTime];
	}
	queryList();
	if (tableRef.value && toolbarRef.value) {
		tableRef.value.connect(toolbarRef.value);
	}
	getBaseInfo();
});
</script>
